package tomcatJNDI;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.Session;

public class InsertViaHibernate extends HttpServlet {

	/**
	 * Constructor of the object.
	 */
	public InsertViaHibernate() {
		super();
	}

	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		Logger loggerConnect = Logger.getLogger("Connect");
		loggerConnect.debug("In InsertViaHibernate Servlet");
		//
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">");
		out.println("<HTML>");
		out.println("  <HEAD><TITLE>A Servlet</TITLE></HEAD>");
		out.println("  <BODY>");
		out.print("    This is ");
		out.print(this.getClass());
		out.println(", using the GET method");

		Session session = null;
		try {

			session = HibernateUtil.getSessionFactory().getCurrentSession();
			session.beginTransaction();

			Car bigSUV = new Car();
			bigSUV.setManufacturer("BMW");
			bigSUV.setModel("X5");
			bigSUV.setYear(2005);

			Driver jill = getDriverByName("Jill", session);
			addCarToDriver(jill, bigSUV, session);
			session.getTransaction().commit(); // Automatically closes session
		} catch (Exception e) {
			loggerConnect.error("Exception In InsertViaHibernate Servlet: "
					+ e.getMessage());
			session.getTransaction().rollback();
			throw new ServletException();
		}

		out.println("  </BODY>");
		out.println("</HTML>");
		out.flush();
		out.close();
	}

	private Driver getDriverByName(String name, Session session) {
		Query q = session.createQuery("from Driver d where d.name = :name");
		q.setString("name", name);
		Driver newOwner = (Driver) q.list().get(0);
		return newOwner;
	}

	private void addCarToDriver(Driver theOwner, Car theCar, Session session) {
		theOwner.getCarsOwned().add(theCar);
		session.save(theCar);
		session.save(theOwner);
	}

	public void init() throws ServletException {
		// Put your code here
	}

}
