package tomcatJNDI;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

public class Retrieval extends HttpServlet {

	/**
	 * Constructor of the object.
	 */
	public Retrieval() {
		super();
	}

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		Logger loggerConnect = Logger.getLogger("Connect");
		loggerConnect.debug("In Retrieval Servlet");

		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">");
		out.println("<HTML>");
		out.println("  <HEAD><TITLE>A Servlet</TITLE></HEAD>");
		out.println("  <BODY>");
		out.print("    This is ");
		out.print(this.getClass());
		out.println(", using the GET method");

		InitialContext initCtx = null;
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		try {
			// JNDI lookup
			initCtx = new InitialContext();
			DataSource ds = (DataSource) initCtx
					.lookup("java:comp/env/jdbc/Sampdb");
			conn = ds.getConnection();

			out.println("<br><br>");
			out.println("Connection from DataSource successfully opened!<br>");

			stmt = conn.createStatement();
			rs = stmt.executeQuery("select * from Car");

			while (rs.next()) {
				String onerow = "Car manufacturer: "
						+ rs.getString("manufacturer") + ",  model: "
						+ rs.getString("model") + ",  year: "
						+ rs.getString("year") + "<br>";
				out.println(onerow);

			}

			out.println("<br><br>");
			out.println("Connection from DataSource successfully closed!<br>");
		} catch (Exception e) {
			out.println("<br><br>");
			out.println("Connection from DataSource NOT successfully opened!<br>");
			out.println(e.getMessage() + "<br>");
		} finally {
			// clean up code
			try {
				rs.close();
				stmt.close();
				conn.close();
				initCtx.close();
			} catch (Throwable th) {
				// log exception
				loggerConnect.error("In Retrieval Servlet. Clean-up failure.");

			}

		}

		out.println("  </BODY>");
		out.println("</HTML>");
		out.flush();
		out.close();
	}

	public void init() throws ServletException {
		// Put your code here
	}

}
