package tomcatJNDI;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.Session;

public class RetrieveViaHibernate extends HttpServlet {

	/**
	 * Constructor of the object.
	 */
	public RetrieveViaHibernate() {
		super();
	}

	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	/**
	 * The doGet method of the servlet. <br>
	 * 
	 * 
	 * @param request
	 *            the request send by the client to the server
	 * @param response
	 *            the response send by the server to the client
	 * @throws ServletException
	 *             if an error occurred
	 * @throws IOException
	 *             if an error occurred
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">");
		out.println("<HTML>");
		out.println("  <HEAD><TITLE>A Servlet</TITLE></HEAD>");
		out.println("  <BODY>");
		out.print("    This is BRAND NEW ");
		out.print(this.getClass());
		out.println(", using the GET method<br>");

		doQuery(out); // Employ Hibernate to access both Driver and Car tables

		out.println("  </BODY>");
		out.println("</HTML>");
		out.flush();
		out.close();
	}

	private void doQuery(PrintWriter out) {
		Logger loggerConnect = Logger.getLogger("Connect");
		loggerConnect.debug("In RetrieveViaHibernate Servlet");

		try {
			// This step will read hibernate.cfg.xml and prepare hibernate for
			// use
			Session session = HibernateUtil.getSessionFactory().openSession();
			session.beginTransaction();

			String SQL_QUERY = "from Driver driver";
			Query query = session.createQuery(SQL_QUERY);
			for (Iterator it = query.iterate(); it.hasNext();) {
				Driver driver = (Driver) it.next();
				out.println("Driver name: " + driver.getName() + ", ");
				out.println("Driver age: " + driver.getAge() + "<br>");

				Set carsOwned = (Set) driver.getCarsOwned();
				for (Iterator itOwned = carsOwned.iterator(); itOwned.hasNext();) {
					Car carOwned = (Car) itOwned.next();
					out.println("&nbsp;&nbsp;&nbsp;Manufacturer: "
							+ carOwned.getManufacturer() + ", ");
					out.println("Model: " + carOwned.getModel() + ", ");
					out.println("Age: " + carOwned.getYear());
					out.println("<br>");
				}
			}

			session.getTransaction().commit(); // Automatically closes session
		} catch (Exception e) {
			loggerConnect.error("Exception In RetrieveViaHibernate Servlet: "
					+ e.getMessage());
		} finally {
			// put clean up code here
		}

	}

	/**
	 * Initialization of the servlet. <br>
	 * 
	 * @throws ServletException
	 *             if an error occure
	 */
	public void init() throws ServletException {
		// Put your code here
	}

}
